#![no_main]

use organic::parser::parse_with_settings;
use organic::settings::GlobalSettings;
use wasm::ParseResult;
use wasm_bindgen::prelude::wasm_bindgen;

mod wasm;

#[wasm_bindgen]
pub fn parse_org(org_contents: &str) -> wasm_bindgen::JsValue {
    let global_settings = GlobalSettings::default();
    let rust_parsed = parse_with_settings(org_contents, &global_settings)
        .map(|document| ParseResult::Success(document.into()))
        .unwrap_or_else(|err| ParseResult::Error(format!("{:?}", err)));
    serde_wasm_bindgen::to_value(&rust_parsed).unwrap()
}
